
This builds from the previous challenge. You need to have the code built out from the previous challenge.

Mimic:
![](nnG9kMh.png)

As with the previous challenge: When you move mouse over “Greet me” it turns red if on Desktop. When clicked, it fades regardless Desktop or phone. A modal appears after clicking and the modal greets you by your full name.

But in this challenge instead of showing an alert when user clicks “Greet me”, you show a modal:

![](HR2MP38.png)


Modal documents:
[https://reactnative.dev/docs/modal](https://reactnative.dev/docs/modal)

----

**Given up or comparing after you finished?** 

Answer:
```
import { View, Text, TouchableOpacity, TextInput, Modal, StyleSheet } from "react-native";  
import { useState } from 'react'  
  
export default function App(  
) {  
  const [onHover, setOnHover] = useState(0)  
  const [firstName, setFirstName] = useState("")  
  const [lastName, setLastName] = useState("")  
  
  const [modalVisible, setModalVisible] = useState(false);  
  
  return (  
    <View  
      style={{  
        flex: 1,  
        width: "100%",  
        justifyContent: "center",  
        alignItems: "center",  
      }}  
    >  
      <Modal  
        animationType="slide"  
        transparent={true}  
        visible={modalVisible}  
        onRequestClose={() => {  
          Alert.alert('Modal has been closed.');  
          setModalVisible(!modalVisible);  
        }}>  
        <View style={styles.centeredView}>  
          <View style={styles.modalView}>  
            <Text style={styles.modalText}>Greetings, {firstName} {lastName}</Text>  
            <TouchableOpacity  
              style={[styles.mt8, styles.button, styles.buttonClose]}  
              onPress={() => setModalVisible(!modalVisible)}>  
              <Text style={styles.textStyle}>Hide Modal</Text>  
            </TouchableOpacity>  
          </View>  
        </View>  
      </Modal>  
  
      <TextInput  
        style={{ width:"70%", height: 40, borderColor: 'gray', borderWidth: 1 }}  
        onChangeText={text => setFirstName(text)}  
        value={firstName}  
        placeholder=""  
      ></TextInput>  
  
      <TextInput  
        style={{ width:"70%", height: 40, borderColor: 'gray', borderWidth: 1 }}  
        onChangeText={text => setLastName(text)}  
        value={lastName}  
        placeholder=""  
      ></TextInput>  
  
      <TouchableOpacity  
        onMouseEnter={() => setOnHover(1)}  
        onMouseLeave={() => setOnHover(0)}  
      >  
        <Text   
          onPress={()=>setModalVisible(!modalVisible)}  
          style={onHover === 1 ? { color: 'red' } : {}}  
        >Greet me</Text>  
      </TouchableOpacity>  
    </View>  
  );  
}  
  
const styles = StyleSheet.create({  
  mt8: {  
    marginTop: "2rem"  
  },  
  centeredView: {  
    flex: 1,  
    justifyContent: 'center',  
    alignItems: 'center',  
    marginTop: 22,  
  },  
  modalView: {  
    margin: 20,  
    backgroundColor: 'white',  
    borderRadius: 20,  
    padding: 35,  
    alignItems: 'center',  
    shadowColor: '#000',  
    shadowOffset: {  
      width: 0,  
      height: 2,  
    },  
    shadowOpacity: 0.25,  
    shadowRadius: 4,  
    elevation: 5,  
  },  
  button: {  
    borderRadius: 20,  
    padding: 10,  
    elevation: 2,  
  },  
  buttonOpen: {  
    backgroundColor: '#F194FF',  
  },  
  buttonClose: {  
    backgroundColor: '#2196F3',  
  },  
  textStyle: {  
    color: 'white',  
    fontWeight: 'bold',  
    textAlign: 'center',  
  },  
  modalText: {  
    marginBottom: 15,  
    textAlign: 'center',  
  },  
});
```